/*
  To access device, download LocalServer from https://stargate-system.com
  and run it on machine within the same network.

  Before uploading, replace <YOUR WIFI NAME> and <YOUR WIFI PASSWORD>
  with your WiFi credentials
*/

#include "MAX6675.h"
#include <WiFiGateDevice.h>

WiFiGateDevice device("<YOUR WIFI NAME>", "<YOUR WIFI PASSWORD>");

const int SO_PIN = 2;
const int CS_PIN = 3;
const int SCK_PIN = 4;
MAX6675 thermoCouple(CS_PIN, SO_PIN, SCK_PIN);

GateInt reading = device.factory.createInt("output");
GateBool status = device.factory.createBool("output");

const int INTERVAL = 1000;
unsigned long nextMeasurement = 0;

void setup()
{
  device.setName("MAX6675");
  reading.setName("Temperature");
  reading.setMin(0);
  reading.setMax(800);
  status.setName("Status");
  status.setLabelTrue("Ready");
  status.setLabelFalse("Error");

  SPI.begin();
  thermoCouple.begin();
  thermoCouple.setSPIspeed(4000000);
  device.start();
}

void loop()
{
  device.loop();
  if (nextMeasurement < millis()) {
    updateTemperature();
    nextMeasurement = millis() + INTERVAL;
  }
}

void updateTemperature() {
  if (thermoCouple.read() == 0) {
    status.setValue(true);
    reading.setValue(round(thermoCouple.getTemperature()));
  } else {
    status.setValue(false);
  }
}